"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.main = void 0;
const serverless_adapter_1 = require("@h4ad/serverless-adapter");
const digital_ocean_1 = require("@h4ad/serverless-adapter/lib/adapters/digital-ocean");
const trpc_1 = require("@h4ad/serverless-adapter/lib/frameworks/trpc");
const digital_ocean_handler_1 = require("@h4ad/serverless-adapter/lib/handlers/digital-ocean/digital-ocean.handler");
const promise_1 = require("@h4ad/serverless-adapter/lib/resolvers/promise");
const setup_1 = require("./setup");
const framework = new trpc_1.TrpcFramework(setup_1.frameworkOptions);
exports.main = serverless_adapter_1.ServerlessAdapter.new(setup_1.appRouter)
    .setFramework(framework)
    .setHandler(new digital_ocean_handler_1.DigitalOceanHandler())
    .setResolver(new promise_1.PromiseResolver())
    .addAdapter(new digital_ocean_1.HttpFunctionAdapter())
    .build();
