"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EmptyResponse = exports.__ΩIEmptyResponse = exports.DEFAULT_BINARY_CONTENT_TYPES = exports.DEFAULT_BINARY_ENCODINGS = void 0;
/**
 * Default encodings that are treated as binary, they are compared with the `Content-Encoding` header.
 *
 * @breadcrumb Core / Constants
 * @defaultValue ['gzip', 'deflate', 'br']
 * @public
 */
exports.DEFAULT_BINARY_ENCODINGS = ['gzip', 'deflate', 'br'];
/**
 * Default content types that are treated as binary, they are compared with the `Content-Type` header.
 *
 * @breadcrumb Core / Constants
 * @defaultValue [new RegExp('^image/.*$'), new RegExp('^video/.*$'), 'application/pdf']
 * @public
 */
exports.DEFAULT_BINARY_CONTENT_TYPES = [
    new RegExp('^image/.*$'),
    new RegExp('^video/.*$'),
    'application/pdf',
];
const __ΩIEmptyResponse = ['PM'];
exports.__ΩIEmptyResponse = __ΩIEmptyResponse;
/**
 * Constant for empty response and can be used on some adapters when the adapter does not need to return a response.
 *
 * @breadcrumb Core / Constants
 * @public
 */
exports.EmptyResponse = {};
//# sourceMappingURL=constants.js.map