"use strict";
//#region
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpDeepkitFramework = void 0;
const http_1 = require("@deepkit/http");
const core_1 = require("../../core");
const network_1 = require("../../network");
//#endregion
/**
 * The framework that forwards requests to express handler
 *
 * @breadcrumb Frameworks / HttpDeepkitFramework
 * @public
 */
class HttpDeepkitFramework {
    /**
     * {@inheritDoc}
     */
    sendRequest(app, request, response) {
        const flattenedHeaders = (0, core_1.getFlattenedHeadersMap)(request.headers);
        let requestBuilder = new http_1.RequestBuilder(request.url, request.method).headers(flattenedHeaders);
        if (request.body) {
            requestBuilder = Buffer.isBuffer(request.body)
                ? requestBuilder.body(request.body)
                : requestBuilder.body(Buffer.from(request.body));
        }
        const httpRequest = requestBuilder.build();
        app.handleRequest(httpRequest, response);
    }
}
exports.HttpDeepkitFramework = HttpDeepkitFramework;
HttpDeepkitFramework.__type = [() => http_1.HttpKernel, 'app', () => network_1.ServerlessRequest, 'request', 'response', 'sendRequest', () => http_1.HttpKernel, 'PP7!2"P7#2$!2%$0&5P7\'6"'];
//# sourceMappingURL=http-deepkit.framework.js.map