"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpFirebaseHandler = void 0;
const { __ΩFrameworkContract } = require('../../contracts');
function __assignType(fn, args) {
    fn.__type = args;
    return fn;
}
const firebase_functions_1 = require("firebase-functions");
//#endregion
/**
 * The class that implements a handler for Firebase Https Events
 *
 * @remarks Read more about Https Events {@link https://firebase.google.com/docs/functions/http-events | here}
 *
 * @breadcrumb Handlers / HttpFirebaseHandler
 * @public
 */
class HttpFirebaseHandler {
    //#region Public Methods
    /**
     * {@inheritDoc}
     */
    getHandler(app, framework) {
        return firebase_functions_1.https.onRequest(__assignType((request, response) => {
            const serverlessRequest = request;
            if (serverlessRequest.body &&
                typeof serverlessRequest.body === 'object') {
                serverlessRequest.body = Buffer.from(JSON.stringify(serverlessRequest.body), 'utf-8');
            }
            return framework.sendRequest(app, serverlessRequest, response);
        }, ['request', 'response', '', 'P!2!!2""/#']));
    }
}
exports.HttpFirebaseHandler = HttpFirebaseHandler;
HttpFirebaseHandler.__type = ['TApp', 'app', () => __ΩFrameworkContract, 'framework', 'req', 'res', '', 'getHandler', 'b!Pe"!2"e"!o#"2$P!2%!2&P$$`J/\'0(5e!!!!!$P$$`J6\''];
//# sourceMappingURL=http-firebase.handler.js.map