'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var http = require('http');
var url = require('url');
var nodeHTTPRequestHandler = require('../../../dist/nodeHTTPRequestHandler-bf4aabf6.cjs.dev.js');
require('../../../dist/resolveHTTPResponse-5479c10e.cjs.dev.js');
require('../../../dist/transformTRPCResponse-76b8b375.cjs.dev.js');
require('../../../dist/codes-130e62df.cjs.dev.js');

function _interopDefault (e) { return e && e.__esModule ? e : { 'default': e }; }

var http__default = /*#__PURE__*/_interopDefault(http);
var url__default = /*#__PURE__*/_interopDefault(url);

/* eslint-disable @typescript-eslint/no-non-null-assertion */
function createHTTPHandler(opts) {
  return async (req, res) => {
    const endpoint = url__default['default'].parse(req.url).pathname.slice(1);
    await nodeHTTPRequestHandler.nodeHTTPRequestHandler({ ...opts,
      req,
      res,
      path: endpoint
    });
  };
}
function createHTTPServer(opts) {
  const handler = createHTTPHandler(opts);
  const server = http__default['default'].createServer((req, res) => handler(req, res));
  return {
    server,

    listen(port) {
      server.listen(port);
      const actualPort = port === 0 ? server.address().port : port;
      return {
        port: actualPort
      };
    }

  };
}

exports.createHTTPHandler = createHTTPHandler;
exports.createHTTPServer = createHTTPServer;
